diff options
author | Junio C Hamano <gitster@pobox.com> | 2007-12-12 17:34:30 -0800 |
---|---|---|
committer | Junio C Hamano <gitster@pobox.com> | 2007-12-12 17:41:58 -0800 |
commit | 22c9071728cdc4c5b39e4fc6a33036d967d3a3a5 (patch) | |
tree | e09c202f806f38c90df9147a38e843194294ea9b | |
parent | c49d3c8a88916554c5db838c0346b6cf05d60104 (diff) | |
download | git-22c9071728cdc4c5b39e4fc6a33036d967d3a3a5.tar.gz |
git-help -w: do not require to be in git repository
The users used to be able to say "git help cat-file" from anywhere, but
the browse-help script insisted to be in a git repository, which caused
"git help -w cat-file" to barf outside. Correct it.
While at it, remove leftover debugging "echo".
Signed-off-by: Junio C Hamano <gitster@pobox.com>
-rwxr-xr-x | git-browse-help.sh | 13 | ||||
-rwxr-xr-x | git-sh-setup.sh | 45 |
2 files changed, 34 insertions, 24 deletions
diff --git a/git-browse-help.sh b/git-browse-help.sh index 817b3792c8..b465911c9a 100755 --- a/git-browse-help.sh +++ b/git-browse-help.sh @@ -17,8 +17,10 @@ # USAGE='[--browser=browser|--tool=browser] [cmd to display] ...' -SUBDIRECTORY_OK=Yes -OPTIONS_SPEC= + +# This must be capable of running outside of git directory, so +# the vanilla git-sh-setup should not be used. +NONGIT_OK=Yes . git-sh-setup # Install data. @@ -37,7 +39,7 @@ valid_tool() { } init_browser_path() { - browser_path=`git config browser.$1.path` + test -z "$GIT_DIR" || browser_path=`git config browser.$1.path` test -z "$browser_path" && browser_path=$1 } @@ -69,7 +71,8 @@ do shift done -if test -z "$browser"; then +if test -z "$browser" && test -n "$GIT_DIR" +then for opt in "help.browser" "web.browser" do browser="`git config $opt`" @@ -91,7 +94,7 @@ if test -z "$browser" ; then else browser_candidates="w3m links lynx" fi - echo "browser candidates: $browser_candidates" + for i in $browser_candidates; do init_browser_path $i if type "$browser_path" > /dev/null 2>&1; then diff --git a/git-sh-setup.sh b/git-sh-setup.sh index 5aa62dda15..b366761b97 100755 --- a/git-sh-setup.sh +++ b/git-sh-setup.sh @@ -122,26 +122,33 @@ get_author_ident_from_commit () { LANG=C LC_ALL=C sed -ne "$pick_author_script" } -# Make sure we are in a valid repository of a vintage we understand. -if [ -z "$SUBDIRECTORY_OK" ] +# Make sure we are in a valid repository of a vintage we understand, +# if we require to be in a git repository. +if test -n "$NONGIT_OK" then - : ${GIT_DIR=.git} - test -z "$(git rev-parse --show-cdup)" || { - exit=$? - echo >&2 "You need to run this command from the toplevel of the working tree." - exit $exit - } + if git rev-parse --git-dir >/dev/null 2>&1 + then + : ${GIT_DIR=.git} + fi else - GIT_DIR=$(git rev-parse --git-dir) || { - exit=$? - echo >&2 "Failed to find a valid git directory." - exit $exit + if [ -z "$SUBDIRECTORY_OK" ] + then + : ${GIT_DIR=.git} + test -z "$(git rev-parse --show-cdup)" || { + exit=$? + echo >&2 "You need to run this command from the toplevel of the working tree." + exit $exit + } + else + GIT_DIR=$(git rev-parse --git-dir) || { + exit=$? + echo >&2 "Failed to find a valid git directory." + exit $exit + } + fi + test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || { + echo >&2 "Unable to determine absolute path of git directory" + exit 1 } + : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"} fi - -test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || { - echo >&2 "Unable to determine absolute path of git directory" - exit 1 -} - -: ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"} |